Back to Intro to Storybook
Chapters
  • 开始吧
  • 简单 组件
  • 合成组件
  • Data
  • 页面
  • 部署
  • 测试
  • 插件
  • 总结
  • 帮助我们

构建一个简单的组件

单独构建一个简单的组件
此社区翻译尚未更新为最新的Storybook版本。通过应用此翻译的中文指南中的更改来帮助我们更新它。 Pull requests 欢迎他们.

我们将按照组件驱动开发 (CDD) 方法论来 构建我们的 UI。这是一个从“自下而上”开始构建 UI 的过程,从组件开始到整个页面结束。CDD 可帮助您在构建 UI 时,摆列您所面临的复杂程度。

任务-Task

Task component in three states

Task 是我们的应用程序的核心组件。每个任务的显示略有不同,具体取决于它所处的 状态-state。我们显示一个选中 (或未选中) 复选框,一些有关任务的信息,以及一个“pin”按钮,允许我们在列表中上下移动任务。为了把各个它们摆在一起,我们需要下面的 props:

  • title - 描述任务的字符串
  • state - 哪个列表是当前的任务,是否已选中?

在我们开始构建Task时,我们首先编写 与 上面草图中不同类型的任务相对应的测试状态。然后我们使用 Storybook 模拟数据独立构建组件。我们将“视觉测试”组件在每个状态下的外观。

获取设置

首先,让我们创建任务 Task 组件 及 其附带的 story 文件:src/components/Task.jssrc/components/Task.stories.js

我们将从 Task 的基本实现开始,简单传入我们需要的 属性-props 以及需要对任务执行的两个 on 操作(在列表之间移动它):

Copy
src/components/Task.js
import React from 'react';

export default function Task({ task: { id, title, state }, onArchiveTask, onPinTask }) {
  return (
    <div className="list-item">
      <input type="text" value={title} readOnly={true} />
    </div>
  );
}

上面,我们基于 Todos 应用程序现有 HTML 结构为 Task 提供简单的 markup .

下面, 我们在 story 文件中构建 Task 的三个测试状态:

Copy
src/components/Task.stories.js
import React from 'react';

import Task from './Task';

export default {
  component: Task,
  title: 'Task',
};

const Template = (args) => <Task {...args} />;

export const Default = Template.bind({});
Default.args = {
  task: {
    id: '1',
    title: 'Test Task',
    state: 'TASK_INBOX',
    updatedAt: new Date(2018, 0, 1, 9, 0),
  },
};

export const Pinned = Template.bind({});
Pinned.args = {
  task: {
    ...Default.args.task,
    state: 'TASK_PINNED',
  },
};

export const Archived = Template.bind({});
Archived.args = {
  task: {
    ...Default.args.task,
    state: 'TASK_ARCHIVED',
  },
};

Storybook 中有两个基本的组织级别。Component 及其 child stories.

将每个 story 视为 Component 的排列。您可以根据需要为每个组件创建尽可能多的 story。

  • Component
    • Story
    • Story
    • Story

为了告知 Storybook 关于我们正在记录的 component,我们创建了一个 default 默认导出,其中包含:

  • component -- component 组件本身
  • title -- 如何在 Storybook 侧边栏中引用组件

为了定义我们的 stories,我们为每个测试状态导出一个函数用于生成一个 story。story 是一个根据传入的 state 返回一个已渲染元素的函数,就像是 无状态组件

我们的组件有很多排列,因此将其分配给一个 Template 变量是很方便的。将这种模式引入你的 stories 将会减少很多需要编写并维护的代码量。

Template.bind({}) 是一个可以用于复制函数的 JavaScript 标准 技术。我们使用此技术允许每个导出的 story 都使用相同的实现,但能够设置自己的属性。

Arguments 或者 args 简写,不需要重启 Storybook 就可以通过 controls 插件实时编辑我们的组件。一旦 args 被修改,组件就会更新。

在创建 story 时,我们使用基本任务 (task) 构建组件期望的任务的形状。这通常是根据真实数据的模型建模的。再次,正如我们所看到的,export 这种形状将使我们能够在以后的 story 中重复使用它。

Actions 帮助您在隔离构建UI组件时验证交互。通,您无法访问应用程序上下文中的函数和状态。使用 action() 将它们存入。

配置

我们需要对 Storybook 配置进行几处修改,使其不仅可以注意到我们刚创建的 stories,而且还能允许我们使用上个章节中修改过的 CSS 文件。

Copy
.storybook/main.js
module.exports = {
  //👇 Location of our stories
  stories: ['../src/components/**/*.stories.js'],
  addons: [
    '@storybook/addon-links',
    '@storybook/addon-essentials',
    '@storybook/preset-create-react-app',
  ],
};

完成以上修改后,在 .storybook 文件夹中修改 preview.js 为一下内容:

Copy
.storybook/preview.js
import '../src/index.css'; //👈 The app's CSS file goes here

//👇 Configures Storybook to log the actions( onArchiveTask and onPinTask ) in the UI.
export const parameters = {
  actions: { argTypesRegex: '^on[A-Z].*' },
};

parameters 通常用于控制 Storybook 的功能和插件的行为。在我们的例子中我们将使用它来配置如何处理 actions(模拟回调)。

actions 允许我们创建被点击时显示在 Storybook 界面的 actions 面板上的回调。因此当我们构建一个 pin button 时,我们能够在测试界面上验证 button 点击是否成功。

当我们完成这些时,重启 Storybook 服务将产生三个任务状态的测试用例:

建立状态

现在我们有 Storybook 的设置,样式的导入及测试用例的构建,我们可以快速开始组件的匹配设计的 HTML 实现。

目前该组件仍然很基础。首先编写代码实现设计,而无需关注太多细节。

Copy
src/components/Task.js
import React from 'react';

export default function Task({ task: { id, title, state }, onArchiveTask, onPinTask }) {
  return (
    <div className={`list-item ${state}`}>
      <label className="checkbox">
        <input
          type="checkbox"
          defaultChecked={state === 'TASK_ARCHIVED'}
          disabled={true}
          name="checked"
        />
        <span className="checkbox-custom" onClick={() => onArchiveTask(id)} />
      </label>
      <div className="title">
        <input type="text" value={title} readOnly={true} placeholder="Input title" />
      </div>

      <div className="actions" onClick={(event) => event.stopPropagation()}>
        {state !== 'TASK_ARCHIVED' && (
          // eslint-disable-next-line jsx-a11y/anchor-is-valid
          <a onClick={() => onPinTask(id)}>
            <span className={`icon-star`} />
          </a>
        )}
      </div>
    </div>
  );
}

上面的附加 markup 与我们之前导入的 CSS 相结合,产生以下 UI:

特别数据要求

最佳实践是在 React 中使用 propTypes 指定组件期望的数据形态。不仅可以自我记录文档化,也能帮助我们尽早发现问题。

Copy
src/components/Task.js
import React from 'react';
import PropTypes from 'prop-types';

export default function Task({ task: { id, title, state }, onArchiveTask, onPinTask }) {
  // ...
}

Task.propTypes = {
  /** Composition of the task */
  task: PropTypes.shape({
    /** Id of the task */
    id: PropTypes.string.isRequired,
    /** Title of the task */
    title: PropTypes.string.isRequired,
    /** Current state of the task */
    state: PropTypes.string.isRequired,
  }),
  /** Event to change the task to archived */
  onArchiveTask: PropTypes.func,
  /** Event to change the task to pinned */
  onPinTask: PropTypes.func,
};

现在,如果 Task 组件被滥用,将会在开发环境出现警告。

另一种实现方法是使用类似 TypeScript 的 JavaScript 类型系统来为组件属性创建类型。

组件构建!

我们现在已成功构建了一个组件,没用到服务器或运行整个前端应用程序。下一步是以类似的方式逐个构建剩余的 Taskbox 组件。

如您所见,开始单独构建组件非常简单快捷。我们可以期望生成更高质量的 UI,减少错误和更多打磨,因为它可以挖掘并测试每个可能的状态。

自动化测试

Storybook 为我们提供了一种在开发期间,可视化测试我们的应用程序。在我们继续开发应用程序时,stories 将有助于确保我们不会打破 Task 的外观。 但是,在这个阶段,这是一个完全手动的过程,有人必须努力点击每个测试状态,并确保它呈现良好且没有错误或警告。我们不能自动这样做吗?

快照测试

快照测试是指记录给定输入的组件的“已知合格”的输出,然后将来输出发生变化时标记组件的做法。 这补充了 Storybook,因为快照是查看组件新版本并检查更改的快速方法。

确保您的组件呈现 不变 的数据,以便每次快照测试都不会失败。注意日期或随机生成的值等内容。

需要Storyshots 插件为每个故事创建快照测试。 通过添加开发依赖项来使用它:

Copy
yarn add -D @storybook/addon-storyshots react-test-renderer

然后创建一个src/storybook.test.js文件中包含以下内容:

Copy
src/storybook.test.js
import initStoryshots from '@storybook/addon-storyshots';
initStoryshots();

完成上述操作后,我们就可以运行了 yarn test 并看到以下输出:

Task test runner

我们现在为每个 Task 的 stories 进行快照测试。如果我们改变了 Task 的实现,我们会提示您验证更改。

Keep your code in sync with this chapter. View 1e576c5 on GitHub.
Is this free guide helping you? Tweet to give kudos and help other devs find it.
Next Chapter
合成组件
使用更简单的组件 组装复合组件
✍️ Edit on GitHub – PRs welcome!
Join the community
7,932 developers and counting
WhyWhy StorybookComponent-driven UI
DocsGuidesTutorialsChangelogTelemetry
CommunityAddonsGet involvedBlog
ShowcaseExploreAbout
Open source software
Storybook

Maintained by
Chromatic
Special thanks to Netlify and CircleCI

Back to Intro to Storybook
Chapters
  • 开始吧
  • 简单组件
  • 合成组件
  • 数据
  • 页面
  • 部署
  • 视觉测试
  • 插件
  • 总结
  • 贡献

构建一个简单的组件

单独构建一个简单的组件
此社区翻译尚未更新为最新的Storybook版本。通过应用此翻译的中文指南中的更改来帮助我们更新它。 Pull requests 欢迎他们.

我们将按照组件驱动开发 (CDD)来构建我们的 UI。这是一个自下而上的构建 UI 的过程,我们从组件开始以整个页面结束。CDD 可以帮助您在构建 UI 时衡量其复杂性。

任务

任务组件的三个状态

任务(Task)是我们应用程序的核心组件。每个任务根据其状态的不同在显示上会略有不同。我们提供一个选中(未选中)的复选框,一些关于 Task 的信息和一个允许我们上下移动任务的“pin”按钮。我们需要下述的 props 来将它们整合起来:

  • title – 描述任务的字符串
  • state - 当前任务所在列表,以及其是否被选中?

在我们构建Task之前,首先我们根据上述的草图编写测试所需的状态(state)。然后我们使用 Storybook 模拟数据并独立的构建组件。我们可以“视觉测试”组件在每个状态下的外观。

开始设置

首先,让我们创建 task 组件以及它相关的 story 文件:src/components/Task.vuesrc/components/Task.stories.js

我们将从 Task 的基础实现开始,简单传入我们所需要的属性和需要对任务执行的两个操作(在列表之间移动它):

Copy
src/components/Task.vue
<template>
  <div class="list-item">
    <label for="title" :aria-label="task.title">
      <input type="text" readonly :value="task.title" id="title" name="title" />
    </label>
  </div>
</template>

<script>
export default {
  // eslint-disable-next-line vue/multi-word-component-names
  name: "Task",
  props: {
    task: {
      type: Object,
      required: true,
      default: () => ({ id: "", state: "", title: "" }),
      validator: (task) => ["id", "state", "title"].every((key) => key in task),
    },
  },
};
</script>

如上所示,我们基于 Todos 应用程序现有的 HTML 结构为 Task 直接渲染 markup。

如下所示,我们在 story 文件中创建 Task 的三个不同测试状态:

Copy
src/components/Task.stories.js
import { fn } from '@storybook/test';

import Task from './Task.vue';

export const ActionsData = {
  onPinTask: fn(),
  onArchiveTask: fn(),
};

export default {
  component: Task,
  tags: ['autodocs'],
  //👇 Our exports that end in "Data" are not stories.
  excludeStories: /.*Data$/,
  title: 'Task',
  //👇 Our events will be mapped in Storybook UI
  args: {
    ...ActionsData
  },
};

export const Default = {
  args: {
    task: {
      id: '1',
      title: 'Test Task',
      state: 'TASK_INBOX',
    },
  },
};

export const Pinned = {
  args: {
    task: {
      ...Default.args.task,
      state: 'TASK_PINNED',
    },
  },
};

export const Archived = {
  args: {
    task: {
      ...Default.args.task,
      state: 'TASK_ARCHIVED',
    },
  },
};

💡 Actions 可以帮助一在构建独立的 UI 组件时进行交互验证。一般来说,你无法访问程序上下文中的函数及状态。使用 fn() 可以做到。

Storybook 有两个基本的组织级别:组件和他的 story。可以将每个 story 视作其组件的排列组合。您可以根据需要给每一个组件创建任意个 story。

  • 组件

    • Story

    • Story

    • Story

为了告诉 Storybook 我们正在文档化的组件,我们创建了一个 default 的默认导出,其中包含:

  • component -- 组件本身
  • title -- 如何在 Storybook 应用侧边栏中引用组件
  • tags -- 自动为我们的组件生成文档
  • excludeStories -- story 本身需要但是不用在 Storybook 应用中渲染的信息
  • args -- 在每个 story 中具体说明 args 的行为

为了定义我们的 stories,我们将使用 Component Story Format 3 (也即 CSF3 )构建所有的测试用例。这种形式被设计用来以一种简洁的方式构建我们所用到的测试用例。通过导出包含每个组件状态的对象,我们可以更直观地定义测试,并更有效地创建和复用 story。

Arguments 或者简写 args ,让我们可以在不重启 Storybook 的前提下实时编辑我们的组件。一旦 args 的值被修改我们的组件也会进行相应的更新。

fn() 允许我们创建 Storybook UI 的 actions 面板被点击时显示的回调。因此当我们构建一个 pin button 时,我们能够在 UI 上验证 button 点击是否成功。

由于我们需要将相同的一组 actions 传入到组件的所有排列组合中,将它们合并到一个 actionsData 变量中,并在我们每次定义 story 的时候传入将会变得非常方便。

值得一提的是当我们将组件所需的操作都合并到 actionsData 之后,我们可以在其他组件复用此组件时,让其他组件的 story 也可以复用 exportactionsData,详见下文。

当创建一个 story 时,我们使用一个基本的 task 变量来构建 task 组件所期望的形状。通常是根据真实数据来进行建模的。再次说明,export-ing 这个语法将让我们在之后的 story 中复用,之后将会看到。

配置

我们需要对 Storybook 的配置做几处修改,这样不仅可以识别到近期创建的 story,并且允许我们使用应用程序的 CSS 文件(位于 src/index.css)。

首先,修改您的 Storybook 配置文件(.storybook/main.js) 为以下内容:

Copy
.storybook/main.js
/** @type { import('@storybook/vue3-vite').StorybookConfig } */
const config = {
- stories: ['../src/**/*.mdx', '../src/**/*.stories.@(js|jsx|ts|tsx)'],
+ stories: ['../src/components/**/*.stories.js'],
  staticDirs: ['../public'],
  addons: [
    '@storybook/addon-links',
    '@storybook/addon-essentials',
    '@storybook/addon-interactions',
  ],
  framework: {
    name: '@storybook/vue3-vite',
    options: {},
  },
};
export default config;

完成上述的修改后,修改位于 .storybook文件夹中的 preview.js 为以下内容:

Copy
.storybook/preview.js
+ import '../src/index.css';

//👇 Configures Storybook to log the actions( onArchiveTask and onPinTask ) in the UI.
/** @type { import('@storybook/vue3').Preview } */
const preview = {
  parameters: {
    controls: {
      matchers: {
        color: /(background|color)$/i,
        date: /Date$/,
      },
    },
  },
};

export default preview;

parameters 通常用来控制 Storybook 功能和插件的行为。在我们的例子中,我们并不需要用到这个能力。相反,我们将会导入我们应用的 CSS 文件。

当我们完成这些,重启 Storybook 服务将会生成三种 Task 状态的测试用例:

建立状态

现在我们配置好了 Storybook,导入了样式并且构建了测试用例,接下来我们可以根据设计快速编写组件的 HTML 代码。

当前组件仍然非常基础。首先,编写可以实现设计的代码,无需深入细节。

Copy
src/components/Task.vue
<template>
  <div :class="classes">
    <label
      :for="'checked' + task.id"
      :aria-label="'archiveTask-' + task.id"
      class="checkbox"
    >
      <input
        type="checkbox"
        :checked="isChecked"
        disabled
        :name="'checked' + task.id"
        :id="'archiveTask-' + task.id"
      />
      <span class="checkbox-custom" @click="archiveTask" />
    </label>
    <label :for="'title-' + task.id" :aria-label="task.title" class="title">
      <input
        type="text"
        readonly
        :value="task.title"
        :id="'title-' + task.id"
        name="title"
        placeholder="Input title"
      />
    </label>
    <button
      v-if="!isChecked"
      class="pin-button"
      @click="pinTask"
      :id="'pinTask-' + task.id"
      :aria-label="'pinTask-' + task.id"
    >
      <span class="icon-star" />
    </button>
  </div>
</template>

<script>
import { reactive, computed } from 'vue';

export default {
  // eslint-disable-next-line vue/multi-word-component-names
  name: 'Task',
  props: {
    task: {
      type: Object,
      required: true,
      default: () => ({ id: '', state: '', title: '' }),
      validator: task => ['id', 'state', 'title'].every(key => key in task),
    },
  },
  emits: ['archive-task', 'pin-task'],

  setup(props, { emit }) {
    props = reactive(props);
    return {
      classes: computed(() => ({
        'list-item TASK_INBOX': props.task.state === 'TASK_INBOX',
        'list-item TASK_PINNED': props.task.state === 'TASK_PINNED',
        'list-item TASK_ARCHIVED': props.task.state === 'TASK_ARCHIVED',
      })),
      /**
       * Computed property for checking the state of the task
       */
      isChecked: computed(() => props.task.state === 'TASK_ARCHIVED'),
      /**
       * Event handler for archiving tasks
       */
      archiveTask() {
        emit('archive-task', props.task.id);
      },
      /**
       * Event handler for pinning tasks
       */
      pinTask() {
        emit('pin-task', props.task.id);
      },
    };
  },
};
</script>

上面额外的 markup 与之前导入的 CSS 相结合,得到了如下的 UI:

组件构建完成!

现在我们在没有用到服务器或者运行整个前端应用的情况下成功的构建了一个组件。下一步我们以类似的方式逐步构建剩余的 Taskbox 组件。

如您所见,在独立状态下开始构建组件变得简单高效。我们可以期望生成一个更高质量的 UI,同时包含更少的 Bug 和更多的打磨,因为可以深入并测试所有可能的状态。

捕获无障碍问题

无障碍测试是指基于 WCAG 规则和其他行业所接受的最佳实践,使用自动化测试对渲染的 DOM 进行审计的实践。他们作为 QA 的第一线,捕捉明显违反无障碍的行为,以确保尽可能多的用户可以使用该应用,包括视力障碍、听力问题和认知障碍的残疾人。

Storybook 包含一个官方的无障碍插件。由 Deque's axe-core 驱动,可以捕获 57% WCAG 问题

让我们看看它是如何工作的!执行以下命令安装插件:

Copy
yarn add --dev @storybook/addon-a11y

然后,更新 Storybook 配置文件(.storybook/main.js)来启用它:

Copy
.storybook/main.js
/** @type { import('@storybook/vue3-vite').StorybookConfig } */
module.exports = {
  stories: ['../src/components/**/*.stories.js'],
  staticDirs: ['../public'],
  addons: [
    '@storybook/addon-links',
    '@storybook/addon-essentials',
    '@storybook/addon-interactions',
+   '@storybook/addon-a11y',
  ],
  framework: {
    name: '@storybook/vue3-vite',
    options: {},
  },
};
export default config;

最终,重启你的 Storybook 服务,就可以在 UI 中看到新的插件。

Task accessibility issue in Storybook

回顾我们的 stories,我们可以发现插件在我们的一个测试状态中发现可访问性问题。 "Elements must have sufficient color contrast" 信息实质上意味着在 task 标题和背景之间没有足够的差异性。我们可以快速的修复这个问题,通过修改应用程序的 CSS(位于src/index.css),将文本颜色改为 darker gray 。

Copy
src/index.css
.list-item.TASK_ARCHIVED input[type="text"] {
- color: #a0aec0;
+ color: #4a5568;
  text-decoration: line-through;
}

就是这样!我们已经迈出了第一步确保 UI 变得可访问。随着我们继续增加应用程序的复杂度,我们可以对其他所有组件重复这个过程,而不需要启用额外的工具或测试环境。

💡 别忘记提交您的修改!
Keep your code in sync with this chapter. View 18e218e on GitHub.
Is this free guide helping you? Tweet to give kudos and help other devs find it.
Next Chapter
合成组件
使用更简单的组件组装复合组件
✍️ Edit on GitHub – PRs welcome!
Join the community
7,932 developers and counting
WhyWhy StorybookComponent-driven UI
DocsGuidesTutorialsChangelogTelemetry
CommunityAddonsGet involvedBlog
ShowcaseExploreAbout
Open source software
Storybook

Maintained by
Chromatic
Special thanks to Netlify and CircleCI